Index: bsps/shared/irq/irq-record.c
===================================================================
--- bsps/shared/irq/irq-record.c	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
+++ bsps/shared/irq/irq-record.c	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -0,0 +1,97 @@
+/* SPDX-License-Identifier: BSD-2-Clause */
+
+/**
+ * @file
+ *
+ * @ingroup bsp_interrupt
+ *
+ * @brief This source file contains the implementation of the interrupt event
+ *   recording support.
+ */
+
+/*
+ * Copyright (C) 2022 embedded brains GmbH
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <bsp/irq-generic.h>
+
+#include <rtems/record.h>
+
+/* The regular interrupt entries are registered in this table */
+static rtems_interrupt_entry *
+_Record_Interrupt_dispatch_table[ BSP_INTERRUPT_DISPATCH_TABLE_SIZE ];
+
+/*
+ * Provide one interrupt entry for the _Record_Interrupt_handler() interrupt
+ * dispatch wrapper for each interrupt vector.
+ */
+static rtems_interrupt_entry
+_Record_Interrupt_entry_table[ BSP_INTERRUPT_DISPATCH_TABLE_SIZE ];
+
+rtems_interrupt_entry **bsp_interrupt_get_dispatch_table_slot(
+  rtems_vector_number index
+)
+{
+  return &_Record_Interrupt_dispatch_table[ index ];
+}
+
+static void _Record_Interrupt_handler( void *arg )
+{
+  uintptr_t              vector;
+  rtems_interrupt_entry *entry;
+
+  vector = (uintptr_t) arg;
+  rtems_record_produce( RTEMS_RECORD_INTERRUPT_ENTRY, vector );
+
+  entry = bsp_interrupt_entry_load_acquire(
+    &_Record_Interrupt_dispatch_table[ vector ]
+  );
+
+  if ( RTEMS_PREDICT_TRUE( entry != NULL ) ) {
+    bsp_interrupt_dispatch_entries( entry );
+  } else {
+#if defined(RTEMS_SMP)
+    bsp_interrupt_spurious( vector );
+#else
+    bsp_interrupt_handler_default( vector );
+#endif
+  }
+
+  rtems_record_produce( RTEMS_RECORD_INTERRUPT_EXIT, vector );
+}
+
+void _Record_Interrupt_initialize( void )
+{
+  uintptr_t i;
+
+  /*
+   * Let each interrupt dispatch table slot reference the
+   * _Record_Interrupt_handler() interrupt dispatch wrapper.
+   */
+  for ( i = 0; i < BSP_INTERRUPT_DISPATCH_TABLE_SIZE; ++i ) {
+    _Record_Interrupt_entry_table[ i ].handler = _Record_Interrupt_handler;
+    _Record_Interrupt_entry_table[ i ].arg = (void *) i;
+    bsp_interrupt_dispatch_table[ i ] = &_Record_Interrupt_entry_table[ i ];
+  }
+}
Index: cpukit/doxygen/appl-config.h
===================================================================
--- cpukit/doxygen/appl-config.h	(revision 0d5e41afde424bec6ce59c1e8ce1181980b9844f)
+++ cpukit/doxygen/appl-config.h	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -1911,4 +1911,27 @@
  */
 #define CONFIGURE_RECORD_FATAL_DUMP_BASE64_ZLIB
+
+/* Generated from spec:/acfg/if/record-interrupts-enabled */
+
+/**
+ * @brief This configuration option is a boolean feature define.
+ *
+ * In case
+ *
+ * * this configuration option is defined
+ *
+ * * and #CONFIGURE_RECORD_PER_PROCESSOR_ITEMS is properly defined,
+ *
+ * then the interrupt event recording is enabled.
+ *
+ * @par Default Configuration
+ * If this configuration option is undefined, then the described feature is not
+ * enabled.
+ *
+ * @par Notes
+ * The interrupt event recording generates interrupt entry and exit events when
+ * interrupt entries are dispatched.
+ */
+#define CONFIGURE_RECORD_INTERRUPTS_ENABLED
 
 /* Generated from spec:/acfg/if/record-per-processor-items */
Index: cpukit/include/rtems/confdefs/extensions.h
===================================================================
--- cpukit/include/rtems/confdefs/extensions.h	(revision 0d5e41afde424bec6ce59c1e8ce1181980b9844f)
+++ cpukit/include/rtems/confdefs/extensions.h	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -189,4 +189,12 @@
     RTEMS_SYSINIT_ORDER_MIDDLE
   );
+
+  #ifdef CONFIGURE_RECORD_INTERRUPTS_ENABLED
+    RTEMS_SYSINIT_ITEM(
+      _Record_Interrupt_initialize,
+      RTEMS_SYSINIT_LAST,
+      RTEMS_SYSINIT_ORDER_MIDDLE
+    );
+  #endif
 #endif
 
Index: cpukit/include/rtems/record.h
===================================================================
--- cpukit/include/rtems/record.h	(revision 0d5e41afde424bec6ce59c1e8ce1181980b9844f)
+++ cpukit/include/rtems/record.h	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -67,4 +67,6 @@
 
 void _Record_Initialize( void );
+
+void _Record_Interrupt_initialize( void );
 
 bool _Record_Thread_create(
Index: spec/build/bsps/objirq.yml
===================================================================
--- spec/build/bsps/objirq.yml	(revision 0d5e41afde424bec6ce59c1e8ce1181980b9844f)
+++ spec/build/bsps/objirq.yml	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -22,4 +22,5 @@
 - bsps/shared/irq/irq-legacy.c
 - bsps/shared/irq/irq-lock.c
+- bsps/shared/irq/irq-record.c
 - bsps/shared/irq/irq-server.c
 - bsps/shared/irq/irq-shell.c
Index: spec/build/bsps/powerpc/ss555/bspss555.yml
===================================================================
--- spec/build/bsps/powerpc/ss555/bspss555.yml	(revision 0d5e41afde424bec6ce59c1e8ce1181980b9844f)
+++ spec/build/bsps/powerpc/ss555/bspss555.yml	(revision c46fbb955258df3ff3c325dadd1a6c17ee81a914)
@@ -81,4 +81,5 @@
 - bsps/shared/irq/irq-info.c
 - bsps/shared/irq/irq-lock.c
+- bsps/shared/irq/irq-record.c
 - bsps/shared/irq/irq-server.c
 - bsps/shared/irq/irq-shell.c
